<script type="text/javascript">

var ModelContextMenu;
(function($) {

    ModelContextMenu = $.fn.ContextMenu;

    /**
     * IE fails to apply opacity, if element is too big.
     * @param width of element
     * @param height of element
     * @return true, if opacity can be applied, false otherwise.
     */
    function isOpacityApplicable(width, height) {
        if(!$.browser.msie) {
            return true;
        }
        var maxSize = 16777216; //4096 * 4096
        var size = width * height;
        return (size < maxSize);
    }

	function HoverElement($p_parentelement) {
		var ObjThis = this;
		var $hoverDiv = $('<div class="hover"></div>');
		this.$hoverDiv = $hoverDiv;
		var $actionDiv = $('<div></div>');
		$hoverDiv.append($actionDiv);
		var $hoverBGDiv = $('<div class="hover"></div>');
		this.$hoverBGDiv = $hoverBGDiv;
		// add to parent
		$p_parentelement.append($hoverBGDiv);
		$p_parentelement.append($hoverDiv);

		this.hoverClickFunction = null;
		this.imageClickFunction = null;

        $actionDiv.addClass("actionBox");

/*		$actionDiv.click(function(p_eventObject){ //click object left
			p_eventObject.stopPropagation();
			var img = ($actionDiv.css('background-image').match(/objSelPlus/)) ? '/search/objSelMinus.png' : '/search/objSelPlus.png';
//			alert($actionDiv.css('background-image'));
			$actionDiv.css({'background-image': 'url("'+jsVars.imgPath+img+'")'});
		});
*/		
//		alert(jsVars.imgPath+'search/objSelPlus.png');

        if (!$.isiPad()) {
		    $hoverDiv.addClass("hoverBox");
		    $hoverBGDiv.addClass("hoverBGBox");
		    $hoverBGDiv.fadeTo(0, 0.2);
        } else {
            $hoverDiv.addClass("iPadHoverBox");
		    $hoverBGDiv.addClass("iPadHoverBGBox");
        }
		$actionDiv.hide();


		$actionDiv.click(function(p_eventObject){ //click object left
			if(ObjThis.imageClickFunction) {
				p_eventObject.stopPropagation();
				ObjThis.imageClickFunction(p_eventObject);
			}
		});
		// inform control about click
		$hoverDiv.click(function(p_eventObject){ //click object left
			if(ObjThis.hoverClickFunction) {
				p_eventObject.stopPropagation();
				ObjThis.hoverClickFunction(p_eventObject, false);
			}
		});
		$hoverDiv.noContext();
		$hoverDiv.rightClick(function(p_eventObject) { //click object right
			p_eventObject.stopPropagation();
			ObjThis.hoverClickFunction(p_eventObject, true);
		});

		this.getHoverElement = function() {
			return $hoverDiv;
		};

		this.hideHover = function() {
			var hidePos = { top: -1000, left: -1000, width: 10, height: 10 };
			$hoverDiv.css(hidePos);
            $hoverDiv.attr("title", "");
			$hoverBGDiv.css(hidePos);
			ObjThis.hoverClickFunction = null;
		};

		this.showHover = function(p_selPos, p_functionOnClick, p_imagePath, p_imageClickFunction) {
			$hoverDiv.css({
				top: (p_selPos.top - 2),
				left: (p_selPos.left - 2),
				width: p_selPos.width,
				height: p_selPos.height
			});
            if(isOpacityApplicable(p_selPos.width, p_selPos.height)) {
                $hoverBGDiv.css({
                    top: (p_selPos.top + 2),
                    left: (p_selPos.left + 2),
                    width: p_selPos.width,
                    height: p_selPos.height
                });
            } else {
                $hoverBGDiv.css({
                    width: 0,
                    height: 0
                });
            }
			if(p_imagePath) {
				$actionDiv.css({'background-image': 'url("'+jsVars.imgPath+p_imagePath+'")'});
				$actionDiv.show();
			} else {
				$actionDiv.hide();
			}
			ObjThis.hoverClickFunction = p_functionOnClick;
			ObjThis.imageClickFunction = p_imageClickFunction;
		};

		// hide hover if mouse is leaving object
		$hoverDiv.hover(function(){}, function(){ ObjThis.hideHover(); });
	}


	function ImageFrame($p_parentElementWidget, p_pos, p_modelData, p_idx, p_scaleValue) {
		var ObjThis = this;
		this.pos = p_pos;
		var offset = {'left': p_pos.left, 'top': p_pos.top};
		this.offset = offset;
		this.scrollPos = {'left': 0, 'top': 0};
		var $parent = $p_parentElementWidget;
		this.idx = p_idx;

		//create and append divs
		var $outerDiv = $('<div class="sub"></div>');
		this.$outerDiv = $outerDiv;
        $outerDiv.attr('id', 'frame-outer-' + p_idx);
		var $innerDiv = $('<div class="innerSub"></div>');
		this.$innerDiv = $innerDiv;
        $innerDiv.attr('id', 'frame-inner-' + p_idx);
		$outerDiv.append($innerDiv);
		$p_parentElementWidget.element.append($outerDiv);
		this.hoverElement = new HoverElement($innerDiv);
		var $menuDiv =  $('<div class="menu"></div>');
		this.$menuDiv = $menuDiv;
		$innerDiv.append($menuDiv);
		var $focusDiv = $('<div class="focusHighlight"></div>');
		var $focusDivBorder = $('<div class="focusHighlightBorder"></div>');
		$innerDiv.append($focusDiv);
		$innerDiv.append($focusDivBorder);

		var modelData = p_modelData.getData();

		//style divs
        var styleOffset = ($.support.boxModel) ? -1 : 0;  //separate frames by 1px black line,
                                                          // in boxModel browsers, the borderwith is additional
        var styleRight = (p_idx == 0 || p_idx == 2);  // vertical line
        var styleBottom = (p_idx == 0 || p_idx == 1);  //horizontal line
		$outerDiv.css({
			position: 'absolute',
			overflow: ((p_idx == 3) ? 'scroll' :'hidden'),
			top: p_pos.top,
			left: p_pos.left,
			width: p_pos.width + ((styleRight) ? styleOffset : 0),
			height: p_pos.height + ((styleBottom) ? styleOffset : 0),
			"background-color": modelData.backGroundColor
		});
        if(styleRight) {
            $outerDiv.css('border-right', '1px solid black');
        }
        if(styleBottom) {
            $outerDiv.css('border-bottom', '1px solid black');
        }
        var imgWidth = ((modelData.width - offset.left) < p_pos.width + offset.width) ? p_pos.width - ((p_idx == 3) ? 17 : 0) : modelData.width;
		var imgHeight = ((modelData.height - offset.top) < p_pos.height + offset.height) ? p_pos.height - ((p_idx == 3) ? 17 : 0) : modelData.height;
        $innerDiv.css({
			position: 'relative',
			top: (-(offset.top)),
			left: (-(offset.left)),
			width: imgWidth,
			height: imgHeight,
			'background-image': "url('" + location.protocol + "//" + location.host + modelData.url + "')",
			'background-repeat': 'no-repeat'
		});
		$focusDiv.css({
			position: 'absolute',
			'left': -10000,
			'z-index': 10005
		});
        $focusDivBorder.css({
            position: 'absolute',
			'left': -10000,
			'z-index': 10006
        });

		//events
		$innerDiv.noContext();
		$innerDiv.rightClick(function(p_eventObject) { //click background right
			p_eventObject.stopPropagation();
			$parent.doClickBackground(p_eventObject, ObjThis._calcMousePosInImage(p_eventObject), true);
		});
		$innerDiv.click(function(p_eventObject){  //click background left
			p_eventObject.stopPropagation();
			$parent.doClickBackground(p_eventObject, ObjThis._calcMousePosInImage(p_eventObject), false);
		});
		//scrollable is only frame 3
		if(p_idx == 3) {
			$outerDiv.scroll(function(){
				$parent.doScroll($outerDiv.scrollLeft(), $outerDiv.scrollTop());
			});
		}
		// convert mousemove to 100% size an inform control
		$innerDiv.mousemove(function(p_eventObject){
			$parent.doMouseMove(ObjThis, ObjThis._calcMousePosInImage(p_eventObject));
		});

		// set correct scroll position
		this.setOffset = function(p_left, p_top) {
			this.scrollPos = {'left': p_left, 'top': p_top};
			this.offset = {'left': (this.pos.left + p_left), 'top': (this.pos.top + p_top)};
			if(ObjThis.idx != 3) { // exclude frame 3 that is already scrolled by scrollbars
				$innerDiv.css({
					top: (-(this.offset.top)),
					left: (-(this.offset.left))
				});
			}
		};
		// scroll the image to a new position, used to syncronize the frames
		this.scrollTo = function(p_left, p_top) {
			if(ObjThis.idx == 3) { // update only frame 3, this will cause events that actualize all other frames
				var imgW = modelData.width;
				var imgH = modelData.height;
				var crossX = ObjThis.pos.left;
				var crossY = ObjThis.pos.top;

				$outerDiv.scrollLeft(p_left * (imgW-crossX));
				$outerDiv.scrollTop(p_top * (imgH-crossY));
			}
		};

		//set focus div to given position
		this.setFocus = function(p_structure) {
            var setToFocus = function(p_div, p_structure){
                p_div.css({
                    'top': p_structure[STR_Y] - 2,
                    'left': p_structure[STR_X] - 2,
                    'width': p_structure[STR_WIDTH],
                    'height': p_structure[STR_HEIGHT]
			    });
            };
            if(isOpacityApplicable(p_structure[STR_WIDTH], p_structure[STR_HEIGHT])) {
                setToFocus($focusDiv, p_structure);
            }
            setToFocus($focusDivBorder, p_structure);
		};

		this.hideFocus = function() {
			$focusDiv.css({ 'left': -10000 });
			$focusDivBorder.css({ 'left': -10000 });
		};

		//delegate
		this.hideHover = function() {
			ObjThis.hoverElement.hideHover();
		};
		//delegate and add listener
		this.showHover = function(p_selPos, p_imagePath, p_imageClickFunction) { // get and delegate structure clicks
			ObjThis.hoverElement.showHover(p_selPos, function(p_eventObject, p_isRightMouseClick) {
				$parent.doClickStructure(p_eventObject, ObjThis._calcMousePosInImage(p_eventObject), p_isRightMouseClick, ObjThis.hoverElement.getHoverElement());
			}, p_imagePath, p_imageClickFunction);
		};
        //set quick info text for hover element
        this.setQuickInfo = function(p_text) {
            ObjThis.hoverElement.getHoverElement().attr("title", $.director.util.unquoteHTML(p_text));
        };
		// internal helper translates to image coordinates used in structures
		this._calcMousePosInImage = function(p_eventObject) {
			return { //  + ObjThis.offset.top
				'x': (p_eventObject.pageX - $parent.element.offset().left + ObjThis.scrollPos.left),
				'y': (p_eventObject.pageY - $parent.element.offset().top  + ObjThis.scrollPos.top)
			};
		};

		// calculate positions of the visible rectangle for the overview
		this.getScrollPosForOverview = function() {
			var viewW = ObjThis.pos.width;
			var viewH = ObjThis.pos.height;
			var imgW = modelData.width;
			var imgH = modelData.height;
			var crossX = ObjThis.pos.left;
			var crossY = ObjThis.pos.top;
			if(p_idx == 3) {
				viewW = ((imgW - crossX) < viewW) ? (imgW - crossX) : viewW;
				viewH = ((imgH - crossY) < viewH) ? (imgH - crossY) : viewH;
			}
			var x = (this.offset.left - crossX);
			var y = (this.offset.top - crossY);

			return {
				'x' : (x / (imgW-crossX)),
				'endX': ((x + viewW) / (imgW-crossX)),
				'y' : (y / (imgH-crossY)),
				'endY': ((y + viewH) / (imgH-crossY))
			};
	    };

		////////////////////////////////////////////////////////////////////////////////////
		// Highilight
		////////////////////////////////////////////////////////////////////////////////////

		var $HighLightDivsArr = [];
		var $HighLightDivsBorderArr = [];
		var maxNumOfSelectableObjects = 500;
		var ensureEnoughDivs = function(p_numOfNeededDivs) {
			if(p_numOfNeededDivs <= $HighLightDivsArr.length) { return; }
			p_numOfNeededDivs = (p_numOfNeededDivs > maxNumOfSelectableObjects) ? maxNumOfSelectableObjects : p_numOfNeededDivs;
			for(var i=$HighLightDivsArr.length; i<p_numOfNeededDivs; i++) {
                var appendHighlightDiv = function(p_class){
                    var $div = $('<div class="' + p_class + '"></div>');
                    $innerDiv.append($div);
                    $div.css({
                        position: 'absolute',
                        'z-index': 10000
                    });
                    return $div;
                };
				$HighLightDivsArr[i] = appendHighlightDiv("highlight");
				$HighLightDivsBorderArr[i] = appendHighlightDiv("highlightBorder");
			}
		};

		//highglight given structures
		this.selectStructures = function(p_structureArr) {
			ensureEnoughDivs(p_structureArr.length);
            var moveToPosition = function(p_struct, p_div){
                p_div.css({
                    'top': p_struct[STR_Y] - 2,
					'left': p_struct[STR_X] - 2,
					'width': p_struct[STR_WIDTH],
					'height': p_struct[STR_HEIGHT]
                })
            };
			for(var i=0; i<p_structureArr.length; i++) {
                moveToPosition(p_structureArr[i], $HighLightDivsArr[i]);
                moveToPosition(p_structureArr[i], $HighLightDivsBorderArr[i]);
			}
		};

		// return values may be negative if not in frame 3
		this.calcScrollOffsetForStructure = function(p_structure) {
			//calc center of structure
			var x = p_structure[STR_X] + (p_structure[STR_WIDTH] / 2);
			var y = p_structure[STR_Y] + (p_structure[STR_HEIGHT] / 2);

			//sub half of size of visible area
			x -= $outerDiv.width() / 2;
			y -= $outerDiv.height() / 2;

			//convert to correct format
			var imgW = modelData.width;
			var imgH = modelData.height;
			var crossX = ObjThis.pos.left;
			var crossY = ObjThis.pos.top;
			return { 
				'x': ((x-crossX) / (imgW-crossX)),
				'y': ((y-crossY) / (imgH-crossY))
			}
		};

		this.deselectStructures = function(p_idxToDeselctFrom){
			for(var i=p_idxToDeselctFrom; i<$HighLightDivsArr.length; i++) {
				$HighLightDivsArr[i].css('top', -10000);
                $HighLightDivsBorderArr[i].css('top', -10000);
			}
		};

		//remove possible hihlights
		this.deselectAll = function() {
			$.each($HighLightDivsArr, function(p_idx, $p_val){
				$p_val.css('top', -10000);
			});
            $.each($HighLightDivsBorderArr, function(p_idx, $p_val){
				$p_val.css('top', -10000);
			});
		},

        this.appendSelectionDiv = function(p_element) {
            $innerDiv.append(p_element);
        }
	}

/*
This helper class manages the selected objects
 */
	function SelectionManager(p_defIdArr) {

		var defIDArr = p_defIdArr;
		var NO_FOCUS = -1;
		var raster = 50 * modelCall.scaleValue / 100;
		var rasterOffset = raster / 3;
		var model = $.modelData.getData();

		// a,b = structure
		// this implements the XY-Sorting of the selected objects
		var sortStryctureByXYZComparator = function(p_structureA, p_structureB) {
			var yA = Math.floor((p_structureA[STR_Y] + rasterOffset) / raster);
			var yB = Math.floor((p_structureB[STR_Y] + rasterOffset) / raster);
			if(yA != yB) {
				return yA-yB;
			}
			if(p_structureA[STR_X] != p_structureB[STR_X]) {
				return p_structureA[STR_X]-p_structureB[STR_X];
			}
			return p_structureA[STR_Z]-p_structureB[STR_Z];
		};

		//creates a new array that contains the structuers corresponding to the occIDs
		var occIndexArrayToStructureArray = function(p_occIndexArray) {
			var structArr = [];
			if(p_occIndexArray) {
				$.each(p_occIndexArray, function(idx, occIndex){
					var occ = model.occs[occIndex];
					structArr.push(model.structs[occ[OCC_REF_STRUCTID]]);
				});
			}
			return structArr;
		};

		//init
		var occIndexArr = $.modelData.findOccIndicesForDefIDs(p_defIdArr);
		var sortedOccs = occIndexArrayToStructureArray(occIndexArr);
		sortedOccs.sort(sortStryctureByXYZComparator);

		var occFocusIndex = NO_FOCUS;

		var findIndexOfNearestStructureInArray = function(p_actStructure) {
			if(!sortedOccs) { return NO_FOCUS; }
			if(sortedOccs.length == 0) { return NO_FOCUS; }
			if(!p_actStructure) { return occFocusIndex; }
			for(var i=0; i<sortedOccs.length; i++) {
				var strct = sortedOccs[i];
				if(p_actStructure[STR_IDX] == strct[STR_IDX]) { return i; }
				var compVal = sortStryctureByXYZComparator(p_actStructure, strct);
				if(compVal < 0) { return i; }
			}
			return (sortedOccs.length - 1);			
		};

		this.isStructureInSelection = function(p_actStructure) {
			for(var i=0; i<sortedOccs.length; i++) {
				var strct = sortedOccs[i];
				if(p_actStructure[STR_IDX] == strct[STR_IDX]) {
					return true;
				}
			}
			return false;
		};

		this.getOccIndicesForActualSelection = function() {
			var occIdxArr = [];
			for(var i=0; i<sortedOccs.length; i++) {
				var strct = sortedOccs[i];
				if(strct[STR_TYPE] == 1) {
					occIdxArr.push(sortedOccs[i][STR_REF_IDX]);
				}
			}
			return occIdxArr;
		};

		this.addStructureToSelection = function(p_actStructure) {
			sortedOccs.push(p_actStructure);
			sortedOccs.sort(sortStryctureByXYZComparator);
		};

		this.removeStructureFromSelection = function(p_actStructure) {
			var newArr = [];
			for(var i=0; i<sortedOccs.length; i++) {
				var strct = sortedOccs[i];
				if(p_actStructure[STR_IDX] != strct[STR_IDX]) {
					newArr.push(strct);
				}
			}
			sortedOccs = newArr;
//			sortedOccs.sort(sortStryctureByXYZComparator);
		};

		this.getSortedStructureArray = function() {
			return 	sortedOccs;
		};

		this.getDefIdArray = function() {
			return defIDArr;
		};

		this.getNextFocusStructure = function(p_actFocusStructure) {
			if(!sortedOccs) { return null; }
			if(!p_actFocusStructure) {
				if(occFocusIndex == NO_FOCUS) {
					occFocusIndex = 0;
				} else {
					occFocusIndex += (occFocusIndex >=(sortedOccs.length -1)) ? 0 : 1;
				}
			} else {
				var idx = findIndexOfNearestStructureInArray(p_actFocusStructure);
				if(idx == occFocusIndex) {  //already at this object
					occFocusIndex += (occFocusIndex >= (sortedOccs.length -1)) ? 0 : 1;
				} else {
					occFocusIndex = idx;
				}
			}
			return sortedOccs[occFocusIndex];
		};

		this.getPreviousFocusStructure = function(p_actFocusStructure) {
			if(!sortedOccs) { return null; }
			if(!p_actFocusStructure) {
				if(occFocusIndex == NO_FOCUS) {
					occFocusIndex = 0;
				} else {
					occFocusIndex -= (occFocusIndex < 1) ? 0 : 1;
				}
			} else {
				var idx = findIndexOfNearestStructureInArray(p_actFocusStructure);
				if(idx == occFocusIndex) {  //already at this object
					occFocusIndex -= (occFocusIndex < 1) ? 0 : 1;
				} else {
					occFocusIndex = idx;
				}
			}
			return sortedOccs[occFocusIndex];
		};

		this.clearFocus = function() {
			this.occFocusIndex = NO_FOCUS;
		};
	}


	$.widget("ui.modelGraphic", {

		_init: function() {
			this.options.lastSelObj = null;
			this.options.selection = null;
            this.selectDeffs([]);
		},

		// overview is avoiding ping pong events by itselve
		_informOverview: function() {
//			p_startXFactor, p_endXFactor, p_startYFactor, p_endYFactor
			var scrollPos = this.options.frames[3].getScrollPosForOverview();
			jQuery.director.bp.getModelCommunication().updateOverviewWithVisibleRect(
					scrollPos.x, scrollPos.endX,
					scrollPos.y, scrollPos.endY
			);
		},

		doScroll: function(p_scrollLeft, p_scrollTop) {
			this.options.frames[1].setOffset(p_scrollLeft, 0);
			this.options.frames[2].setOffset(0, p_scrollTop);
			this.options.frames[3].setOffset(p_scrollLeft, p_scrollTop);
			this._informOverview();
		},

		scrollTo: function(p_left, p_top) {
			this.options.frames[3].scrollTo(p_left, p_top);
		},

		doClickBackground: function(p_eventObject, p_mousePosInImage, p_isRightMouseClick, p_menu) {
			var menu;
            if(!p_menu) {
                menu = this.options.modelContextMnu;
            } else {
                menu = p_menu;
            }
            menu.reset();
            this.options.contextSelection = {};

			if(p_isRightMouseClick) {
				if(this.options.onBackgroundRightClick) {
					this.options.onBackgroundRightClick(p_eventObject, p_mousePosInImage, menu);
				}
			} else {
				if(this.options.onBackgroundLeftClick) {
					this.options.onBackgroundLeftClick(p_eventObject, p_mousePosInImage, menu);
				}
			}
		},

		doClickStructure: function(p_eventObject, p_mousePosInImage, p_isRightMouseClick, p_hoverObject, p_menu) {
			var menu;
            if(!p_menu) {
                menu = this.options.modelContextMnu;
            } else {
                menu = p_menu;
            }
            menu.reset();

            this.options.contextSelection = {};
            this.options.contextSelection.event = p_eventObject;
            this.options.contextSelection.mousePos = p_mousePosInImage;

			if(p_isRightMouseClick) {
				if(this.options.onStructureRightClick) {
					this.options.onStructureRightClick(p_eventObject, p_mousePosInImage, p_hoverObject, menu);
				}
			} else {
				if(this.options.onStructureLeftClick) {
					this.options.onStructureLeftClick(p_eventObject, p_mousePosInImage, p_hoverObject, menu);
				}
			}
		},

		doMouseMove: function(p_frame, p_posInImage100) {
			var $this = this;
			var selObjInfo = $.modelData.findHighestElementAtPosition(p_posInImage100);
			var model = $.modelData.getData();
			if(selObjInfo){
				var selObj = model.structs[selObjInfo.id];
				var selPos = {'left': selObj[STR_X], 'top': selObj[STR_Y], 'width': selObj[STR_WIDTH], 'height': selObj[STR_HEIGHT]};
				if(jsVars.isObjectSelectionModeActive && selObj[STR_TYPE] == 1) {
					var selectionDat = this.options.selection;
					var isObjInSelection = selectionDat && selectionDat.isStructureInSelection(selObj);
					if(isObjInSelection) {
						p_frame.showHover(selPos, '/search/objSelMinus.png', function(){
							selectionDat.removeStructureFromSelection(selObj);
							$this._updateSelectedStructures();
						});
					} else {
						p_frame.showHover(selPos, '/search/objSelPlus.png', function(){
							selectionDat.addStructureToSelection(selObj);
							$this._updateSelectedStructures();
						});
					}
				} else {
					p_frame.showHover(selPos);
				}
                //show object name as 'Quick info', if moving mouse over the object 
                if(selObj[STR_TYPE] == 1) {
                    var occDat = model.occs[selObj[STR_REF_IDX]];
				    var defData = model.defs[occDat[OCC_REF_DEFID]];
                    p_frame.setQuickInfo( defData[DEF_NAME] +" ["+ defData[DEF_TYPE] +"] -"+ defData[DEF_TYPE_NAME]+ " GUID: " + defData[DEF_GUID] );
                }
			} else {
				p_frame.hideHover();
			}

		},

		/*
		Hihlight all occs of the given defs
		p_defIdArr = arr of ids of defs
		 */
		selectDeffs: function(p_defIdArr) {
			var selectionDat = new SelectionManager(p_defIdArr);
			var frameDat = this._fillFrameDat(selectionDat);
			// deselect divs that are not visible any more if any
			if(this.options.selection) {
				var oldFrameDat = this.options.selection.frameDat;
				this._deselectDivsNotNeeded(frameDat, oldFrameDat);
			}
			selectionDat.frameDat = frameDat;
			this.options.selection = selectionDat;
			this._showSelectedStructures();
		},

		/*
		Helper to reset the old selection.
		Used after end of object selection
		 */
		resetSelectedDefs: function() {
			var selectionDat = this.options.selection;
			if(!selectionDat) { return; }
			var defIDs = selectionDat.getDefIdArray();
			if(defIDs) {
				this.selectDeffs(defIDs);
			}
		},

		getOccIndicesForActualSelection: function() {
			var selectionDat = this.options.selection;
			if(!selectionDat) { return []; }
			return selectionDat.getOccIndicesForActualSelection();
		},

		_deselectDivsNotNeeded: function(frameDat, oldFrameDat) {
			if(oldFrameDat) {
				for(var frameID=0; frameID<4; frameID++) {
					if(oldFrameDat[frameID].length > frameDat[frameID].length) {
						this.options.frames[frameID].deselectStructures(frameDat[frameID].length);
					}
				}
			}
		},

		_fillFrameDat: function(selectionDat) {
			var frameDat = [[],[],[],[]]; //one arr for each frame
			var structArr = selectionDat.getSortedStructureArray();
			$.each(structArr, function(idx, struct){
				frameDat[struct[STR_FRAMEID]].push(struct);
			});
			return frameDat;
		},

		_updateSelectedStructures: function() {
			var selectionDat = this.options.selection;
			if(!selectionDat) { return; }
			var frameDat = this._fillFrameDat(selectionDat);
			this._deselectDivsNotNeeded(frameDat,  this.options.selection.frameDat);
			selectionDat.frameDat = frameDat;
			this._showSelectedStructures();
		},

		_showSelectedStructures: function() {
			if(!this.options.selection) { return; }
			var selection = this.options.selection;
			var frames = this.options.frames;
			if(!frames) { return; }
			for(var frameID=0; frameID<4; frameID++) {
				frames[frameID].selectStructures(selection.frameDat[frameID]);
			}
		},

		deselectAll: function() {
			for(var frameID=0; frameID<4; frameID++) {
				this.options.frames[frameID].deselectAll();
			}
			this.options.selection = null;
		},

		goToNextFocus: function() {
			var selection = this.options.selection;
			if(selection) {
				var struct = selection.getNextFocusStructure(this.options.lastSelectedFocus);
				this._applyIndexToFocus(struct);
			}
		},

		goToPreviousFocus: function() {
			var selection = this.options.selection;
			if(selection) {
				var struct = selection.getPreviousFocusStructure(this.options.lastSelectedFocus);
				this._applyIndexToFocus(struct);
			}
		},

        setActualFocusAgain: function() {
            var selection = this.options.selection;
            if(selection) {
                var struct = this.options.lastSelectedFocus;
                this._applyIndexToFocus(struct);
            }
        },

		_applyIndexToFocus: function(p_struct) {
			if(p_struct) {
				this.setFocus(p_struct, true);
				//open obj-inf
				var model = $.modelData.getData();
				var occDat = model.occs[p_struct[STR_REF_IDX]];
				var defData = model.defs[occDat[OCC_REF_DEFID]];
//				openObjectInfo(defData[DEF_ID]);
			}
		},

		setFocus: function(p_structure, p_isToScrollTo) {
			var frames = this.options.frames;
			if(!frames) { return; }
			this.options.lastSelectedFocus = p_structure;
			for(var frameID=0; frameID<4; frameID++) {
				if(p_structure[STR_FRAMEID] == frameID) {
					frames[frameID].setFocus(p_structure);
				} else {
					frames[frameID].hideFocus();
				}
			}
			if(p_isToScrollTo) {
				frameID = p_structure[STR_FRAMEID];
				var point = frames[frameID].calcScrollOffsetForStructure(p_structure);
				var x = (point.x > 0 ? point.x : 0);
				var y = (point.y > 0 ? point.y : 0);
				this.scrollTo(x, y);
			}
			$.director.bp.getModelCommunication().setFocusedStructureIndex(p_structure[STR_IDX]);
		},

		hideFocus: function() {
			var frames = this.options.frames;
			if(!frames) { return; }
			for(var frameID=0; frameID<4; frameID++) {
				frames[frameID].hideFocus();
			}
			$.director.bp.getModelCommunication().setFocusedStructureIndex(-1);
		},

		/*
		Hihlight all occs of the given def(s) and focus on first one
		p_ids = single def id or arr of ids of defs
		 */
		highlightAndFocusByDefIDs: function(p_ids) {
			if(!$.isArray(p_ids)) {
				p_ids = [p_ids];
			}
			this.selectDeffs(p_ids);
			this.goToPreviousFocus();
		},



		setImage: function(p_modelData) {
			var $this = this; //for later use in inner function with there own 'this'
			this.options.model = p_modelData; //store model data in options
			var model = p_modelData.getData();

			// gen needed tags and div-frames
			this.element.empty();
			var frames = [];
			this.options.frames = frames;

			var height = $(window).height() - this.element.position().top;
			//height can't be negative, set to zero if < 0
			if(height < 0) {
			    height =  0;
			}

			//update styles
			this.element.css({
				overflow: 'hidden',
				position: 'relative',
				width: '100%',
				height: height,
				'background-color': '#fff'
			});

			var elemWidth = this.element.width() - this.options.scrollBarSize.width;
			var elemHeight = this.element.height() - this.options.scrollBarSize.height;
			var availableWidth = elemWidth - model.crossPoint.left;
			var availableHeight = elemHeight - model.crossPoint.top;

			for(var i=0; i<4; i++){
				var pos = {
					'left':   ((i==0 || i==2) ? 0 : model.crossPoint.left - 1),
					'top':    ((i<2) ? 0 : model.crossPoint.top),
					'width':  ((i==0 || i==2) ? model.crossPoint.left : (availableWidth + ((i==1 || i==3) ? this.options.scrollBarSize.width + 1 : 0))),
					'height': ((i<2) ? model.crossPoint.top : (availableHeight + ((i==2 || i==3) ? this.options.scrollBarSize.height : 0 )))
				};

                //values can't be negative, set to zero if < 0
				if(pos.width < 0) {
				    pos.width = 0;
				}
				if(pos.height < 0) {
				    pos.height = 0;
				}
				//create image frame
				frames[i] = new ImageFrame(this, pos, p_modelData, i, 100);
			}
			this.options.modelContextMnu = new ModelContextMenu(this.element);

			this._informOverview();
			this._showSelectedStructures();

			//re-set focus
            var modelComm = $.director.bp.getModelCommunication();
            var actModelId = modelComm.getActiveModelId();
            var myId = model.call.modelId;
            var focusIdx = modelComm.getFocusedStructureIndex();
			if((focusIdx != -1) && (actModelId == myId) && !jsVars.isViewSelected) {
				var struct = model.structs[focusIdx];
				this.setFocus(struct, false);
			}

            if($.isiPad() && jsVars.isObjectSelectionModeActive) {
                this.showiPadSelectionButtons();
            }
		},

        showiPadSelectionButtons: function() {
            var structs = $.modelData.getData().structs;
            var OBJ_ID = 1;
            var frames = this.options.frames;
            var $self = this;
            var selectionDat = this.options.selection;

            $.each(structs, function(idx, struct) {
                if(struct[STR_TYPE] == OBJ_ID) {
                    var $actionDiv = $('<div>');
                    $actionDiv.css({
                        width: 24,
                        height: 24,
                        position: 'absolute',
                        left: struct[STR_X] + struct[STR_WIDTH] - 16,
                        top: struct[STR_Y] - 8,
                        zIndex: 30000
                    });

                    if(selectionDat.isStructureInSelection(struct)) {
                        $actionDiv.css('background-image', 'url("' + jsVars.imgPath + '/search/objSelMinus_iPad.png")');
                    } else {
                        $actionDiv.css('background-image', 'url("' + jsVars.imgPath + '/search/objSelPlus_iPad.png")');
                    }

                    $self._updateSelectedStructures();
                    $actionDiv.click(function(event) {
                        if(!selectionDat.isStructureInSelection(struct)) {
                            $actionDiv.css('background-image', 'url("' + jsVars.imgPath + '/search/objSelMinus_iPad.png")');
                            //add div to selection
							selectionDat.addStructureToSelection(struct);
                        } else {
                            $actionDiv.css('background-image', 'url("' + jsVars.imgPath + '/search/objSelPlus_iPad.png")');
                            //remove from selection
                            selectionDat.removeStructureFromSelection(struct);
                        }
                        $self._updateSelectedStructures();
                        event.stopPropagation();
                        event.preventDefault();

                    });
                    frames[struct[STR_FRAMEID]].appendSelectionDiv($actionDiv);
                }
            });
        }
	});

	$.extend($.ui.modelGraphic, {
		version: "1.0.0",
		defaults: {
			scrollBarSize: { width: 17, height: 17 },
			onStructureLeftClick: function(p_eventObject, p_mousePosInImage, p_hoverObject, p_menu){},
			onStructureRightClick: function(p_eventObject, p_mousePosInImage, p_hoverObject, p_menu){},
			onBackgroundLeftClick: function(p_eventObject, p_mousePosInImage, p_menu){},
			onBackgroundRightClick: function(p_eventObject, p_mousePosInImage, p_menu){}
		}
	});
	$.ui.modelGraphic.getter = "getOccIndicesForActualSelection";

})(jQuery);
</script>
